function [grad] = computeGradient(QP_map, sigma_Gs)
%UNTITLED7 Summary of this function goes here
%   Detailed explanation goes here
[w,h] = size(QP_map);
filt_size = 11;
GDFx = zeros(filt_size,filt_size,length(sigma_Gs));
GDFy = zeros(filt_size,filt_size,length(sigma_Gs));
for ii = 1:length(sigma_Gs)
    [GDFx(:,:,ii),GDFy(:,:,ii)] = GaussianDerivative_2D(filt_size,sigma_Gs(ii));
end

[xx,yy] = meshgrid(1:w,1:h);
xx = xx-(w+1)/2;
yy = yy-(h+1)/2;
R = sqrt(xx.^2+yy.^2);

grad = zeros(w,h,length(sigma_Gs));
for ii = 1:length(sigma_Gs)
    Gx = imfilter(QP_map,GDFx(:,:,ii),'replicate');
    Gy = imfilter(QP_map,GDFy(:,:,ii),'replicate');
    grad(:,:,ii) = Gx.*xx./R + Gy.*yy./R;
end

end