function [feat_map_18,feat_map_9] = genFeatsMaps(img,block_size, w, c)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here
% crop image to integer multiples of block_size.
[width,height,~] = size(img);
w_res = mod(width,block_size);
h_res = mod(height,block_size);
img = img(floor(w_res/2)+1:width-ceil(w_res/2),floor(h_res/2)+1:width-ceil(h_res/2),:);

% feature maps.
feat_map_18 = zeros(size(img,1)/block_size,size(img,2)/block_size,14);

h = fspecial('gaussian',7,7/6);
%% Original Scale.
% compute MSCN coefficients.
MSCN_img = zeros(size(img));
for ii = 1:size(img,3)
    img_noisy = img(:,:,ii) + randn(size(img(:,:,ii)))*w;
    mu = filter2(h, img_noisy, 'same');
    mu_sq = mu.*mu;
    sigma = sqrt(abs(filter2(h, img_noisy.*img_noisy, 'same') - mu_sq));
    MSCN_img(:,:,ii)     = (img_noisy-mu)./(sigma+c);
end

% SV-GGD estimations.
func_svggd = @(block_struct) estimateSVGGD(block_struct.data(:), true);
feat_map_18(:,:,1:2) = blockproc(MSCN_img,[block_size,block_size],func_svggd);

%SV-AGGD estimations.
shifts = [0, 1; 1, 0 ; 1, 1; -1, 1];
func_svaggd = @(block_struct) estimateSVAGGD(block_struct.data(:),true);
for itr_shift = 1:4
    shifted_MSCN = circshift(MSCN_img,shifts(itr_shift,:));
    MSCN_pair_prod = MSCN_img.*shifted_MSCN;
    feat_map_18(:,:,(itr_shift-1)*4+3:(itr_shift-1)*4+6) = blockproc(MSCN_pair_prod,[block_size,block_size],func_svaggd);
end
%% Downscale by 0.5.
img = imresize(img,0.5);
feat_map_9 = zeros(size(img,1)/block_size,size(img,2)/block_size,9);
MSCN_img = zeros(size(img));
for ii = 1:size(img,3)
    img_noisy = img(:,:,ii) + randn(size(img(:,:,ii)))*w;
    mu = filter2(h, img_noisy, 'same');
    mu_sq = mu.*mu;
    sigma = sqrt(abs(filter2(h, img_noisy.*img_noisy, 'same') - mu_sq));
    MSCN_img(:,:,ii)     = (img_noisy-mu)./(sigma+c);
end

% SV-GGD estimations.
func_svggd = @(block_struct) estimateSVGGD(block_struct.data(:), false);
feat_map_9(:,:,1) = blockproc(MSCN_img,[block_size,block_size],func_svggd);

%SV-AGGD estimations.
shifts = [0, 1; 1, 0 ; 1, 1; -1, 1];
func_svaggd = @(block_struct) estimateSVAGGD(block_struct.data(:),false);
for itr_shift = 1:4
    shifted_MSCN = circshift(MSCN_img,shifts(itr_shift,:));
    MSCN_pair_prod = MSCN_img.*shifted_MSCN;
    feat_map_9(:,:,(itr_shift-1)*2+2:(itr_shift-1)*2+3) = blockproc(MSCN_pair_prod,[block_size,block_size],func_svaggd);
end
end

